<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<?php include_http_metas() ?>
	<?php include_metas() ?>
	<?php include_title() ?>
	<link rel="icon" href="/images/favicon.ico" /><link rel="SHORTCUT ICON" href="/images/favicon.ico" />
</head>
<body>
<div class="base">
	<?php include_partial('global/branding') ?>
	<?php echo use_helper("Asset","Date") ?>
	<div class="session">
		<?php if($sf_user->isAuthenticated()): ?>
		<ul>
		<li><?php echo image_tag("information.gif","alt=[?]")?><b>Logged in as:</b> <span class="adminname"><?php echo $sf_user->getNickname() ?></span> (<span class="adminrole"><?php echo $sf_user->getRoleName() ?></span>) | <?php echo link_to("Settings","user/settings") ?> | <?php echo link_to("Logout","user/logout") ?></li>
		<li><b>Last Login:</b> <?php if($sf_user->getLastLogin()!=""): ?>
		<?php echo format_date($sf_user->getLastLogin(),array('P','t')) ?>
		<?php else: ?>
		<?php echo "Never" ?>
		<?php endif; ?></li>
		<li id="indicator"><?php echo image_tag("load.gif", "alt=[...] border=0") ?> loading</li>
		</ul>
		<?php else: ?>
		<ul><li><?php echo image_tag("warning.gif","alt=[!]")?><b>You are not authenticated.</b> | <?php echo link_to("Login","user/login") ?></li></ul>
		<?php endif; ?>
	</div>
	<?php if($sf_user->isAuthenticated()): ?>
	<?php include_partial("global/navigation", array("module" => $sf_context->getModuleName(), "action" => $sf_context->getActionName())) ?>
	<?php endif; ?>
	<?php echo $sf_data->getRaw('sf_content') ?>
	<?php include_partial('global/notes') ?>
</div>
</body>
</html>
