[?php use_helper('I18N', 'Date', 'Tag', 'Javascript') ?]

<div id="context">

<h1><?php echo $this->getI18NString('list.title', $this->getModuleName().' list') ?></h1>

<div id="sf_admin_header">
[?php include_partial('<?php echo $this->getModuleName() ?>/list_header', array('pager' => $pager)) ?]
[?php include_partial('<?php echo $this->getModuleName() ?>/list_messages', array('pager' => $pager)) ?]
</div>

<div id="sf_admin_content">
<span class="summary"><b>[?php echo __('Results') ?]:</b> [?php echo $pager->getNbResults() ?]</span><span class="summary"><b>Entries per Page:</b> [?php echo select_tag("resultsperpage", options_for_select(<?php $opt = $this->getParameterValue('list.max_per_page_options', array(10,25,50,100)); var_export(@array_combine($opt,$opt)); ?>, $pager->getMaxPerPage()), array("onchange" => "document.location.href = '".url_for('<?php echo $this->getModuleName() ?>/list')."?max_per_page='+this.value")) ?]</span><?php if ($this->getParameterValue('list.filters')): ?><span class="summary toggle">[?php echo link_to_function(__('Toggle Filter Settings'), visual_effect('toggle_blind', 'sf_admin_filters' )) ?]</span>
<?php endif; ?>

<?php if ($this->getParameterValue('list.filters')): ?>
<div id="sf_admin_bar">
[?php include_partial('filters', array('filters' => $filters)) ?]
</div>
<?php endif; ?>

[?php include_partial('pager', array('pager' => $pager, 'location' => 'top')) ?]
<hr size="1" />
[?php if (!$pager->getNbResults()): ?]
[?php echo __('no result') ?]
[?php else: ?]
[?php include_partial('<?php echo $this->getModuleName() ?>/list', array('pager' => $pager)) ?]
[?php endif; ?]
<hr size="1" />
[?php include_partial('pager', array('pager' => $pager, 'location' => 'bottom')) ?]
[?php include_partial('list_actions') ?]
</div>

<div id="sf_admin_footer">
[?php include_partial('<?php echo $this->getModuleName() ?>/list_footer', array('pager' => $pager)) ?]
</div>

</div>
